diff --git a/src/gui/painting/qdrawhelper.cpp b/src/gui/painting/qdrawhelper.cpp
index b3f9fd9..2399acf 100644
--- a/src/gui/painting/qdrawhelper.cpp
+++ b/src/gui/painting/qdrawhelper.cpp
@@ -1798,7 +2022,7 @@ static inline uint interpolate_4_pixels_16(uint tl, uint tr, uint bl, uint br, i
 #endif
 
 #if defined(__SSE2__)
-static inline QRgba64 interpolate_4_pixels_rgb64(QRgba64 t[], QRgba64 b[], uint distx, uint disty)
+static inline QRgba64 interpolate_4_pixels_rgb64(const QRgba64 t[], const QRgba64 b[], uint distx, uint disty)
 {
     const __m128i vdistx = _mm_shufflelo_epi16(_mm_cvtsi32_si128(distx), _MM_SHUFFLE(0, 0, 0, 0));
     const __m128i vidistx = _mm_shufflelo_epi16(_mm_cvtsi32_si128(0x10000 - distx), _MM_SHUFFLE(0, 0, 0, 0));
@@ -1821,7 +2045,7 @@ static inline QRgba64 interpolate_4_pixels_rgb64(QRgba64 t[], QRgba64 b[], uint
 #endif
 }
 #else
-static inline QRgba64 interpolate_4_pixels_rgb64(QRgba64 t[], QRgba64 b[], uint distx, uint disty)
+static inline QRgba64 interpolate_4_pixels_rgb64(const QRgba64 t[], const QRgba64 b[], uint distx, uint disty)
 {
     const uint dx = distx>>8;
     const uint dy = disty>>8;
@@ -2758,11 +2982,11 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
             const uchar *s1 = data->texture.scanLine(y1);
             const uchar *s2 = data->texture.scanLine(y2);
 
-            FetchPixelFunc fetch = qFetchPixel[layout->bpp];
-            uint sbuf1[buffer_size];
-            uint sbuf2[buffer_size];
+            FetchPixelFunc64 fetch = qFetchPixel64[layout->bpp];
             QRgba64 buf1[buffer_size];
             QRgba64 buf2[buffer_size];
+            quint64 *sbuf1 = reinterpret_cast<quint64*>(buf1);
+            quint64 *sbuf2 = reinterpret_cast<quint64*>(buf2);
             QRgba64 *b = buffer;
             while (length) {
                 int len = qMin(length, buffer_size / 2);
@@ -2772,44 +2996,78 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
 #if defined(__SSE2__)
                 const __m128i vdy = _mm_set1_epi16(disty);
                 const __m128i vidy = _mm_set1_epi16(0x10000 - disty);
-                if (blendType != BlendTransformedBilinearTiled && layout->bpp == QPixelLayout::BPP32) {
+                if (blendType != BlendTransformedBilinearTiled
+                    && (layout->bpp == QPixelLayout::BPP32 || layout->bpp == QPixelLayout::BPP64)) {
                     for (; i < len; ++i) {
                         int x1 = (fx >> 16);
                         int x2;
                         fetchTransformedBilinear_pixelBounds<blendType>(image_width, image_x1, image_x2, x1, x2);
                         if (x1 != x2)
                             break;
-                        sbuf1[i * 2 + 0] = ((const uint*)s1)[x1];
-                        sbuf1[i * 2 + 1] = ((const uint*)s1)[x2];
-                        sbuf2[i * 2 + 0] = ((const uint*)s2)[x1];
-                        sbuf2[i * 2 + 1] = ((const uint*)s2)[x2];
+                        if (layout->bpp == QPixelLayout::BPP64) {
+                            sbuf1[i * 2 + 0] = ((const quint64*)s1)[x1];
+                            sbuf1[i * 2 + 1] = ((const quint64*)s1)[x2];
+                            sbuf2[i * 2 + 0] = ((const quint64*)s2)[x1];
+                            sbuf2[i * 2 + 1] = ((const quint64*)s2)[x2];
+                        } else {
+                            sbuf1[i * 2 + 0] = ((const uint*)s1)[x1];
+                            sbuf1[i * 2 + 1] = ((const uint*)s1)[x2];
+                            sbuf2[i * 2 + 0] = ((const uint*)s2)[x1];
+                            sbuf2[i * 2 + 1] = ((const uint*)s2)[x2];
+                        }
                         fx += fdx;
                     }
 
                     const __m128i v_fdx = _mm_set1_epi32(fdx*4);
                     __m128i v_fx = _mm_setr_epi32(fx, fx + fdx, fx + fdx + fdx, fx + fdx + fdx + fdx);
-                    for (; i < len-3; i+=4) {
-                        int offset = _mm_extract_epi16(v_fx, 1);
-                        sbuf1[i * 2 + 0] = ((const uint*)s1)[offset];
-                        sbuf1[i * 2 + 1] = ((const uint*)s1)[offset + 1];
-                        sbuf2[i * 2 + 0] = ((const uint*)s2)[offset];
-                        sbuf2[i * 2 + 1] = ((const uint*)s2)[offset + 1];
-                        offset = _mm_extract_epi16(v_fx, 3);
-                        sbuf1[i * 2 + 2] = ((const uint*)s1)[offset];
-                        sbuf1[i * 2 + 3] = ((const uint*)s1)[offset + 1];
-                        sbuf2[i * 2 + 2] = ((const uint*)s2)[offset];
-                        sbuf2[i * 2 + 3] = ((const uint*)s2)[offset + 1];
-                        offset = _mm_extract_epi16(v_fx, 5);
-                        sbuf1[i * 2 + 4] = ((const uint*)s1)[offset];
-                        sbuf1[i * 2 + 5] = ((const uint*)s1)[offset + 1];
-                        sbuf2[i * 2 + 4] = ((const uint*)s2)[offset];
-                        sbuf2[i * 2 + 5] = ((const uint*)s2)[offset + 1];
-                        offset = _mm_extract_epi16(v_fx, 7);
-                        sbuf1[i * 2 + 6] = ((const uint*)s1)[offset];
-                        sbuf1[i * 2 + 7] = ((const uint*)s1)[offset + 1];
-                        sbuf2[i * 2 + 6] = ((const uint*)s2)[offset];
-                        sbuf2[i * 2 + 7] = ((const uint*)s2)[offset + 1];
-                        v_fx = _mm_add_epi32(v_fx, v_fdx);
+                    if (layout->bpp == QPixelLayout::BPP64) {
+                        for (; i < len-3; i+=4) {
+                            int offset = _mm_extract_epi16(v_fx, 1);
+                            sbuf1[i * 2 + 0] = ((const quint64*)s1)[offset];
+                            sbuf1[i * 2 + 1] = ((const quint64*)s1)[offset + 1];
+                            sbuf2[i * 2 + 0] = ((const quint64*)s2)[offset];
+                            sbuf2[i * 2 + 1] = ((const quint64*)s2)[offset + 1];
+                            offset = _mm_extract_epi16(v_fx, 3);
+                            sbuf1[i * 2 + 2] = ((const quint64*)s1)[offset];
+                            sbuf1[i * 2 + 3] = ((const quint64*)s1)[offset + 1];
+                            sbuf2[i * 2 + 2] = ((const quint64*)s2)[offset];
+                            sbuf2[i * 2 + 3] = ((const quint64*)s2)[offset + 1];
+                            offset = _mm_extract_epi16(v_fx, 5);
+                            sbuf1[i * 2 + 4] = ((const quint64*)s1)[offset];
+                            sbuf1[i * 2 + 5] = ((const quint64*)s1)[offset + 1];
+                            sbuf2[i * 2 + 4] = ((const quint64*)s2)[offset];
+                            sbuf2[i * 2 + 5] = ((const quint64*)s2)[offset + 1];
+                            offset = _mm_extract_epi16(v_fx, 7);
+                            sbuf1[i * 2 + 6] = ((const quint64*)s1)[offset];
+                            sbuf1[i * 2 + 7] = ((const quint64*)s1)[offset + 1];
+                            sbuf2[i * 2 + 6] = ((const quint64*)s2)[offset];
+                            sbuf2[i * 2 + 7] = ((const quint64*)s2)[offset + 1];
+                            v_fx = _mm_add_epi32(v_fx, v_fdx);
+                        }
+                    } else {
+                        for (; i < len-3; i+=4) {
+                            int offset = _mm_extract_epi16(v_fx, 1);
+                            sbuf1[i * 2 + 0] = ((const uint*)s1)[offset];
+                            sbuf1[i * 2 + 1] = ((const uint*)s1)[offset + 1];
+                            sbuf2[i * 2 + 0] = ((const uint*)s2)[offset];
+                            sbuf2[i * 2 + 1] = ((const uint*)s2)[offset + 1];
+                            offset = _mm_extract_epi16(v_fx, 3);
+                            sbuf1[i * 2 + 2] = ((const uint*)s1)[offset];
+                            sbuf1[i * 2 + 3] = ((const uint*)s1)[offset + 1];
+                            sbuf2[i * 2 + 2] = ((const uint*)s2)[offset];
+                            sbuf2[i * 2 + 3] = ((const uint*)s2)[offset + 1];
+                            offset = _mm_extract_epi16(v_fx, 5);
+                            sbuf1[i * 2 + 4] = ((const uint*)s1)[offset];
+                            sbuf1[i * 2 + 5] = ((const uint*)s1)[offset + 1];
+                            sbuf2[i * 2 + 4] = ((const uint*)s2)[offset];
+                            sbuf2[i * 2 + 5] = ((const uint*)s2)[offset + 1];
+                            offset = _mm_extract_epi16(v_fx, 7);
+                            sbuf1[i * 2 + 6] = ((const uint*)s1)[offset];
+                            sbuf1[i * 2 + 7] = ((const uint*)s1)[offset + 1];
+                            sbuf2[i * 2 + 6] = ((const uint*)s2)[offset];
+                            sbuf2[i * 2 + 7] = ((const uint*)s2)[offset + 1];
+                            v_fx = _mm_add_epi32(v_fx, v_fdx);
+                        }
                     }
                     fx = _mm_cvtsi128_si32(v_fx);
                 }
@@ -2819,12 +3077,16 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                     int x2;
                     fetchTransformedBilinear_pixelBounds<blendType>(image_width, image_x1, image_x2, x1, x2);
 
-                    if (layout->bpp == QPixelLayout::BPP32) {
+                    if (layout->bpp == QPixelLayout::BPP64) {
+                        sbuf1[i * 2 + 0] = ((const quint64*)s1)[x1];
+                        sbuf1[i * 2 + 1] = ((const quint64*)s1)[x2];
+                        sbuf2[i * 2 + 0] = ((const quint64*)s2)[x1];
+                        sbuf2[i * 2 + 1] = ((const quint64*)s2)[x2];
+                    } else if (layout->bpp == QPixelLayout::BPP32) {
                         sbuf1[i * 2 + 0] = ((const uint*)s1)[x1];
                         sbuf1[i * 2 + 1] = ((const uint*)s1)[x2];
                         sbuf2[i * 2 + 0] = ((const uint*)s2)[x1];
                         sbuf2[i * 2 + 1] = ((const uint*)s2)[x2];
-
                     } else {
                         sbuf1[i * 2 + 0] = fetch(s1, x1);
                         sbuf1[i * 2 + 1] = fetch(s1, x2);
@@ -2862,11 +3124,11 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                 b += len;
             }
         } else { //rotation
-            FetchPixelFunc fetch = qFetchPixel[layout->bpp];
-            uint sbuf1[buffer_size];
-            uint sbuf2[buffer_size];
+            FetchPixelFunc64 fetch = qFetchPixel64[layout->bpp];
             QRgba64 buf1[buffer_size];
             QRgba64 buf2[buffer_size];
+            quint64 *sbuf1 = reinterpret_cast<quint64*>(buf1);
+            quint64 *sbuf2 = reinterpret_cast<quint64*>(buf2);
             QRgba64 *end = buffer + length;
             QRgba64 *b = buffer;
 
@@ -2876,7 +3138,8 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                 int fracY = fy;
                 int i = 0;
 #if defined(__SSE2__)
-                if (blendType != BlendTransformedBilinearTiled && layout->bpp == QPixelLayout::BPP32) {
+                if (blendType != BlendTransformedBilinearTiled
+                    && (layout->bpp == QPixelLayout::BPP32 || layout->bpp == QPixelLayout::BPP64)) {
                     for (; i < len; ++i) {
                         int x1 = (fx >> 16);
                         int x2;
@@ -2888,10 +3151,17 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                             break;
                         const uchar *s1 = data->texture.scanLine(y1);
                         const uchar *s2 = data->texture.scanLine(y2);
-                        sbuf1[i * 2 + 0] = ((const uint*)s1)[x1];
-                        sbuf1[i * 2 + 1] = ((const uint*)s1)[x2];
-                        sbuf2[i * 2 + 0] = ((const uint*)s2)[x1];
-                        sbuf2[i * 2 + 1] = ((const uint*)s2)[x2];
+                        if (layout->bpp == QPixelLayout::BPP64) {
+                            sbuf1[i * 2 + 0] = ((const quint64*)s1)[x1];
+                            sbuf1[i * 2 + 1] = ((const quint64*)s1)[x2];
+                            sbuf2[i * 2 + 0] = ((const quint64*)s2)[x1];
+                            sbuf2[i * 2 + 1] = ((const quint64*)s2)[x2];
+                        } else {
+                            sbuf1[i * 2 + 0] = ((const uint*)s1)[x1];
+                            sbuf1[i * 2 + 1] = ((const uint*)s1)[x2];
+                            sbuf2[i * 2 + 0] = ((const uint*)s2)[x1];
+                            sbuf2[i * 2 + 1] = ((const uint*)s2)[x2];
+                        }
                         fx += fdx;
                         fy += fdy;
                     }
@@ -2903,7 +3173,8 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                     const int bytesPerLine = data->texture.bytesPerLine;
                     const uchar *s1 = data->texture.imageData;
                     const uchar *s2 = s1 + bytesPerLine;
-                    const __m128i vbpl = _mm_shufflelo_epi16(_mm_cvtsi32_si128(bytesPerLine/4), _MM_SHUFFLE(0, 0, 0, 0));
+                    int pbl = (layout->bpp == QPixelLayout::BPP64) ? bytesPerLine/8 : bytesPerLine/4;
+                    const __m128i vbpl = _mm_shufflelo_epi16(_mm_cvtsi32_si128(pbl), _MM_SHUFFLE(0, 0, 0, 0));
                     for (; i < len-3; i+=4) {
                         if (fdx > 0 && (short)_mm_extract_epi16(v_fx, 7) >= image_x2)
                             break;
@@ -2918,26 +3189,47 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                         voffset = _mm_add_epi32(voffset, _mm_srli_epi32(v_fx, 16));
 
                         int offset = _mm_cvtsi128_si32(voffset); voffset = _mm_srli_si128(voffset, 4);
-                        sbuf1[i * 2 + 0] = ((const uint*)s1)[offset];
-                        sbuf1[i * 2 + 1] = ((const uint*)s1)[offset + 1];
-                        sbuf2[i * 2 + 0] = ((const uint*)s2)[offset];
-                        sbuf2[i * 2 + 1] = ((const uint*)s2)[offset + 1];
-                        offset = _mm_cvtsi128_si32(voffset); voffset = _mm_srli_si128(voffset, 4);
-                        sbuf1[i * 2 + 2] = ((const uint*)s1)[offset];
-                        sbuf1[i * 2 + 3] = ((const uint*)s1)[offset + 1];
-                        sbuf2[i * 2 + 2] = ((const uint*)s2)[offset];
-                        sbuf2[i * 2 + 3] = ((const uint*)s2)[offset + 1];
-                        offset = _mm_cvtsi128_si32(voffset); voffset = _mm_srli_si128(voffset, 4);
-                        sbuf1[i * 2 + 4] = ((const uint*)s1)[offset];
-                        sbuf1[i * 2 + 5] = ((const uint*)s1)[offset + 1];
-                        sbuf2[i * 2 + 4] = ((const uint*)s2)[offset];
-                        sbuf2[i * 2 + 5] = ((const uint*)s2)[offset + 1];
-                        offset = _mm_cvtsi128_si32(voffset);
-                        sbuf1[i * 2 + 6] = ((const uint*)s1)[offset];
-                        sbuf1[i * 2 + 7] = ((const uint*)s1)[offset + 1];
-                        sbuf2[i * 2 + 6] = ((const uint*)s2)[offset];
-                        sbuf2[i * 2 + 7] = ((const uint*)s2)[offset + 1];
-
+                        if (layout->bpp == QPixelLayout::BPP64) {
+                            sbuf1[i * 2 + 0] = ((const quint64*)s1)[offset];
+                            sbuf1[i * 2 + 1] = ((const quint64*)s1)[offset + 1];
+                            sbuf2[i * 2 + 0] = ((const quint64*)s2)[offset];
+                            sbuf2[i * 2 + 1] = ((const quint64*)s2)[offset + 1];
+                            offset = _mm_cvtsi128_si32(voffset); voffset = _mm_srli_si128(voffset, 4);
+                            sbuf1[i * 2 + 2] = ((const quint64*)s1)[offset];
+                            sbuf1[i * 2 + 3] = ((const quint64*)s1)[offset + 1];
+                            sbuf2[i * 2 + 2] = ((const quint64*)s2)[offset];
+                            sbuf2[i * 2 + 3] = ((const quint64*)s2)[offset + 1];
+                            offset = _mm_cvtsi128_si32(voffset); voffset = _mm_srli_si128(voffset, 4);
+                            sbuf1[i * 2 + 4] = ((const quint64*)s1)[offset];
+                            sbuf1[i * 2 + 5] = ((const quint64*)s1)[offset + 1];
+                            sbuf2[i * 2 + 4] = ((const quint64*)s2)[offset];
+                            sbuf2[i * 2 + 5] = ((const quint64*)s2)[offset + 1];
+                            offset = _mm_cvtsi128_si32(voffset);
+                            sbuf1[i * 2 + 6] = ((const quint64*)s1)[offset];
+                            sbuf1[i * 2 + 7] = ((const quint64*)s1)[offset + 1];
+                            sbuf2[i * 2 + 6] = ((const quint64*)s2)[offset];
+                            sbuf2[i * 2 + 7] = ((const quint64*)s2)[offset + 1];
+                        } else {
+                            sbuf1[i * 2 + 0] = ((const uint*)s1)[offset];
+                            sbuf1[i * 2 + 1] = ((const uint*)s1)[offset + 1];
+                            sbuf2[i * 2 + 0] = ((const uint*)s2)[offset];
+                            sbuf2[i * 2 + 1] = ((const uint*)s2)[offset + 1];
+                            offset = _mm_cvtsi128_si32(voffset); voffset = _mm_srli_si128(voffset, 4);
+                            sbuf1[i * 2 + 2] = ((const uint*)s1)[offset];
+                            sbuf1[i * 2 + 3] = ((const uint*)s1)[offset + 1];
+                            sbuf2[i * 2 + 2] = ((const uint*)s2)[offset];
+                            sbuf2[i * 2 + 3] = ((const uint*)s2)[offset + 1];
+                            offset = _mm_cvtsi128_si32(voffset); voffset = _mm_srli_si128(voffset, 4);
+                            sbuf1[i * 2 + 4] = ((const uint*)s1)[offset];
+                            sbuf1[i * 2 + 5] = ((const uint*)s1)[offset + 1];
+                            sbuf2[i * 2 + 4] = ((const uint*)s2)[offset];
+                            sbuf2[i * 2 + 5] = ((const uint*)s2)[offset + 1];
+                            offset = _mm_cvtsi128_si32(voffset);
+                            sbuf1[i * 2 + 6] = ((const uint*)s1)[offset];
+                            sbuf1[i * 2 + 7] = ((const uint*)s1)[offset + 1];
+                            sbuf2[i * 2 + 6] = ((const uint*)s2)[offset];
+                            sbuf2[i * 2 + 7] = ((const uint*)s2)[offset + 1];
+                        }
                         v_fx = _mm_add_epi32(v_fx, v_fdx);
                         v_fy = _mm_add_epi32(v_fy, v_fdy);
                     }
@@ -2956,12 +3248,16 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                     const uchar *s1 = data->texture.scanLine(y1);
                     const uchar *s2 = data->texture.scanLine(y2);
 
-                    if (layout->bpp == QPixelLayout::BPP32) {
+                    if (layout->bpp == QPixelLayout::BPP64) {
+                        sbuf1[i * 2 + 0] = ((const quint64*)s1)[x1];
+                        sbuf1[i * 2 + 1] = ((const quint64*)s1)[x2];
+                        sbuf2[i * 2 + 0] = ((const quint64*)s2)[x1];
+                        sbuf2[i * 2 + 1] = ((const quint64*)s2)[x2];
+                    } else if (layout->bpp == QPixelLayout::BPP32) {
                         sbuf1[i * 2 + 0] = ((const uint*)s1)[x1];
                         sbuf1[i * 2 + 1] = ((const uint*)s1)[x2];
                         sbuf2[i * 2 + 0] = ((const uint*)s2)[x1];
                         sbuf2[i * 2 + 1] = ((const uint*)s2)[x2];
-
                     } else {
                         sbuf1[i * 2 + 0] = fetch(s1, x1);
                         sbuf1[i * 2 + 1] = fetch(s1, x2);
@@ -2992,11 +3288,11 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
         qreal fy = data->m22 * cy + data->m12 * cx + data->dy;
         qreal fw = data->m23 * cy + data->m13 * cx + data->m33;
 
-        FetchPixelFunc fetch = qFetchPixel[layout->bpp];
-        uint sbuf1[buffer_size];
-        uint sbuf2[buffer_size];
+        FetchPixelFunc64 fetch = qFetchPixel64[layout->bpp];
         QRgba64 buf1[buffer_size];
         QRgba64 buf2[buffer_size];
+        quint64 *sbuf1 = reinterpret_cast<quint64*>(buf1);
+        quint64 *sbuf2 = reinterpret_cast<quint64*>(buf2);
         QRgba64 *b = buffer;
 
         int distxs[buffer_size / 2];
@@ -3023,12 +3319,16 @@ static const QRgba64 *QT_FASTCALL fetchTransformedBilinear64(QRgba64 *buffer, co
                 const uchar *s1 = data->texture.scanLine(y1);
                 const uchar *s2 = data->texture.scanLine(y2);
 
-                if (layout->bpp == QPixelLayout::BPP32) {
+                if (layout->bpp == QPixelLayout::BPP64) {
+                    sbuf1[i * 2 + 0] = ((const quint64*)s1)[x1];
+                    sbuf1[i * 2 + 1] = ((const quint64*)s1)[x2];
+                    sbuf2[i * 2 + 0] = ((const quint64*)s2)[x1];
+                    sbuf2[i * 2 + 1] = ((const quint64*)s2)[x2];
+                } else if (layout->bpp == QPixelLayout::BPP32) {
                     sbuf1[i * 2 + 0] = ((const uint*)s1)[x1];
                     sbuf1[i * 2 + 1] = ((const uint*)s1)[x2];
                     sbuf2[i * 2 + 0] = ((const uint*)s2)[x1];
                     sbuf2[i * 2 + 1] = ((const uint*)s2)[x2];
-
                 } else {
                     sbuf1[i * 2 + 0] = fetch(s1, x1);
                     sbuf1[i * 2 + 1] = fetch(s1, x2);
@@ -3089,6 +3389,9 @@ static SourceFetchProc sourceFetch[NBlendTypes][QImage::NImageFormats] = {
         fetchUntransformed,         // Format_A2RGB30_Premultiplied
         fetchUntransformed,         // Alpha8
         fetchUntransformed,         // Grayscale8
+        fetchUntransformed,
+        fetchUntransformed,
+        fetchUntransformed,
     },
     // Tiled
     {
@@ -3117,6 +3420,9 @@ static SourceFetchProc sourceFetch[NBlendTypes][QImage::NImageFormats] = {
         fetchUntransformed,         // A2RGB30_Premultiplied
         fetchUntransformed,         // Alpha8
         fetchUntransformed,         // Grayscale8
+        fetchUntransformed,
+        fetchUntransformed,
+        fetchUntransformed,
     },
     // Transformed
     {
@@ -3145,6 +3451,9 @@ static SourceFetchProc sourceFetch[NBlendTypes][QImage::NImageFormats] = {
         fetchTransformed<BlendTransformed>,         // A2RGB30_Premultiplied
         fetchTransformed<BlendTransformed>,         // Alpah8
         fetchTransformed<BlendTransformed>,         // Grayscale8
+        fetchTransformed<BlendTransformed>,         // Grayscale16
+        fetchTransformed<BlendTransformed>,         // RGB48
+        fetchTransformed<BlendTransformed>,         // RGBA64_Premultiplied
     },
     {
         0, // TransformedTiled
@@ -3172,6 +3481,9 @@ static SourceFetchProc sourceFetch[NBlendTypes][QImage::NImageFormats] = {
         fetchTransformed<BlendTransformedTiled>,            // A2RGB30_Premultiplied
         fetchTransformed<BlendTransformedTiled>,            // Alpha8
         fetchTransformed<BlendTransformedTiled>,            // Grayscale8
+        fetchTransformed<BlendTransformedTiled>,            // Grayscale16
+        fetchTransformed<BlendTransformedTiled>,            // RGB48
+        fetchTransformed<BlendTransformedTiled>,            // RGBA64_Premultiplied
     },
     {
         0, // Bilinear
@@ -3199,6 +3511,9 @@ static SourceFetchProc sourceFetch[NBlendTypes][QImage::NImageFormats] = {
         fetchTransformedBilinear<BlendTransformedBilinear>,         // A2RGB30_Premultiplied
         fetchTransformedBilinear<BlendTransformedBilinear>,         // Alpha8
         fetchTransformedBilinear<BlendTransformedBilinear>,         // Grayscale8
+        fetchTransformedBilinear<BlendTransformedBilinear>,         // Grayscale16
+        fetchTransformedBilinear<BlendTransformedBilinear>,         // RGB48
+        fetchTransformedBilinear<BlendTransformedBilinear>,         // RGBA64_Premultiplied
     },
     {
         0, // BilinearTiled
@@ -3226,6 +3541,9 @@ static SourceFetchProc sourceFetch[NBlendTypes][QImage::NImageFormats] = {
         fetchTransformedBilinear<BlendTransformedBilinearTiled>,            // A2RGB30_Premultiplied
         fetchTransformedBilinear<BlendTransformedBilinearTiled>,            // Alpha8
         fetchTransformedBilinear<BlendTransformedBilinearTiled>,            // Grayscale8
+        fetchTransformedBilinear<BlendTransformedBilinearTiled>,            // Grayscale16
+        fetchTransformedBilinear<BlendTransformedBilinearTiled>,            // RGB48
+        fetchTransformedBilinear<BlendTransformedBilinearTiled>,            // RGBA64_Premultiplied
     },
 };
 
@@ -3257,6 +3575,9 @@ static SourceFetchProc64 sourceFetch64[NBlendTypes][QImage::NImageFormats] = {
         fetchUntransformed64,         // Format_A2RGB30_Premultiplied
         fetchUntransformed64,         // Alpha8
         fetchUntransformed64,         // Grayscale8
+        fetchUntransformed64,         // Grayscale16
+        fetchUntransformedRGBA64PM,   // RGBX64
+        fetchUntransformedRGBA64PM,   // RGBA64_Premultiplied
     },
     // Tiled
     {
@@ -3285,6 +3606,9 @@ static SourceFetchProc64 sourceFetch64[NBlendTypes][QImage::NImageFormats] = {
         fetchUntransformed64,         // A2RGB30_Premultiplied
         fetchUntransformed64,         // Alpha8
         fetchUntransformed64,         // Grayscale8
+        fetchUntransformed64,         // Grayscale16
+        fetchUntransformedRGBA64PM,   // RGBX64
+        fetchUntransformedRGBA64PM,   // RGBA64_Premultiplied
     },
     // Transformed
     {
@@ -3313,6 +3637,9 @@ static SourceFetchProc64 sourceFetch64[NBlendTypes][QImage::NImageFormats] = {
         fetchTransformed64<BlendTransformed>,         // A2RGB30_Premultiplied
         fetchTransformed64<BlendTransformed>,         // Alpah8
         fetchTransformed64<BlendTransformed>,         // Grayscale8
+        fetchTransformed64<BlendTransformed>,
+        fetchTransformed64<BlendTransformed>,
+        fetchTransformed64<BlendTransformed>,
     },
     {
         0, // TransformedTiled
@@ -3340,6 +3667,9 @@ static SourceFetchProc64 sourceFetch64[NBlendTypes][QImage::NImageFormats] = {
         fetchTransformed64<BlendTransformedTiled>,            // A2RGB30_Premultiplied
         fetchTransformed64<BlendTransformedTiled>,            // Alpha8
         fetchTransformed64<BlendTransformedTiled>,            // Grayscale8
+        fetchTransformed64<BlendTransformedTiled>,
+        fetchTransformed64<BlendTransformedTiled>,
+        fetchTransformed64<BlendTransformedTiled>,
     },
     {
         0, // Bilinear
@@ -3367,6 +3697,9 @@ static SourceFetchProc64 sourceFetch64[NBlendTypes][QImage::NImageFormats] = {
         fetchTransformedBilinear64<BlendTransformedBilinear>,         // A2RGB30_Premultiplied
         fetchTransformedBilinear64<BlendTransformedBilinear>,         // Alpha8
         fetchTransformedBilinear64<BlendTransformedBilinear>,         // Grayscale8
+        fetchTransformedBilinear64<BlendTransformedBilinear>,
+        fetchTransformedBilinear64<BlendTransformedBilinear>,
+        fetchTransformedBilinear64<BlendTransformedBilinear>,
     },
     {
         0, // BilinearTiled
@@ -3394,6 +3727,9 @@ static SourceFetchProc64 sourceFetch64[NBlendTypes][QImage::NImageFormats] = {
         fetchTransformedBilinear64<BlendTransformedBilinearTiled>,            // A2RGB30_Premultiplied
         fetchTransformedBilinear64<BlendTransformedBilinearTiled>,            // Alpha8
         fetchTransformedBilinear64<BlendTransformedBilinearTiled>,            // Grayscale8
+        fetchTransformedBilinear64<BlendTransformedBilinearTiled>,
+        fetchTransformedBilinear64<BlendTransformedBilinearTiled>,
+        fetchTransformedBilinear64<BlendTransformedBilinearTiled>,
     },
 };
 
@@ -3866,7 +4202,8 @@ void blend_color_generic_rgb64(int count, const QSpan *spans, void *userData)
             int l = qMin(buffer_size, length);
             QRgba64 *dest = op.destFetch64(buffer, data->rasterBuffer, x, spans->y, l);
             op.funcSolid64(dest, l, color, spans->coverage);
-            op.destStore64(data->rasterBuffer, x, spans->y, dest, l);
+            if (op.destStore64)
+                op.destStore64(data->rasterBuffer, x, spans->y, dest, l);
             length -= l;
             x += l;
         }
@@ -4055,7 +4392,7 @@ public:
 
     bool isSupported() const
     {
-        return op.func64 && op.destFetch64 && op.destStore64;
+        return op.func64 && op.destFetch64;
     }
 
     const QRgba64 *fetch(int x, int y, int len)
@@ -4071,7 +4408,8 @@ public:
 
     void store(int x, int y, int len)
     {
-        op.destStore64(data->rasterBuffer, x, y, dest, len);
+        if (op.destStore64)
+            op.destStore64(data->rasterBuffer, x, y, dest, len);
     }
 };
 
@@ -4178,7 +4516,8 @@ static void blend_untransformed_generic_rgb64(int count, const QSpan *spans, voi
                     const QRgba64 *src = op.srcFetch64(src_buffer, &op, data, sy, sx, l);
                     QRgba64 *dest = op.destFetch64(buffer, data->rasterBuffer, x, spans->y, l);
                     op.func64(dest, src, l, coverage);
-                    op.destStore64(data->rasterBuffer, x, spans->y, dest, l);
+                    if (op.destStore64)
+                        op.destStore64(data->rasterBuffer, x, spans->y, dest, l);
                     x += l;
                     sx += l;
                     length -= l;
@@ -4422,7 +4761,8 @@ static void blend_tiled_generic_rgb64(int count, const QSpan *spans, void *userD
             const QRgba64 *src = op.srcFetch64(src_buffer, &op, data, sy, sx, l);
             QRgba64 *dest = op.destFetch64(buffer, data->rasterBuffer, x, spans->y, l);
             op.func64(dest, src, l, coverage);
-            op.destStore64(data->rasterBuffer, x, spans->y, dest, l);
+            if (op.destStore64)
+                op.destStore64(data->rasterBuffer, x, spans->y, dest, l);
             x += l;
             sx += l;
             length -= l;
@@ -5309,6 +5649,9 @@ static const ProcessSpans processTextureSpans[NBlendTypes][QImage::NImageFormats
         blend_untransformed_generic_rgb64,
         blend_untransformed_generic,
         blend_untransformed_generic,
+        blend_untransformed_generic_rgb64,
+        blend_untransformed_generic_rgb64,
+        blend_untransformed_generic_rgb64,
     },
     // Tiled
     {
@@ -5365,6 +5708,9 @@ static const ProcessSpans processTextureSpans[NBlendTypes][QImage::NImageFormats
         blend_src_generic_rgb64,
         blend_src_generic,
         blend_src_generic,
+        blend_src_generic_rgb64,
+        blend_src_generic_rgb64,
+        blend_src_generic_rgb64,
     },
      // TransformedTiled
     {
@@ -5392,6 +5738,9 @@ static const ProcessSpans processTextureSpans[NBlendTypes][QImage::NImageFormats
         blend_src_generic_rgb64,
         blend_src_generic,
         blend_src_generic,
+        blend_src_generic_rgb64,
+        blend_src_generic_rgb64,
+        blend_src_generic_rgb64,
     },
     // Bilinear
     {
@@ -5420,6 +5769,9 @@ static const ProcessSpans processTextureSpans[NBlendTypes][QImage::NImageFormats
         blend_src_generic_rgb64,
         blend_src_generic,
         blend_src_generic,
+        blend_src_generic_rgb64,
+        blend_src_generic_rgb64,
+        blend_src_generic_rgb64,
     },
     // BilinearTiled
     {
@@ -5448,6 +5800,9 @@ static const ProcessSpans processTextureSpans[NBlendTypes][QImage::NImageFormats
         blend_src_generic_rgb64, // A2RGB30_Premultiplied
         blend_src_generic, // Alpha8
         blend_src_generic, // Grayscale8
+        blend_src_generic_rgb64, // Grayscale16
+        blend_src_generic_rgb64, // RGB48
+        blend_src_generic_rgb64, // RGBA64_Premultiplied
     }
 };
 
